function [gatesignal] = moduleselector_RSF(voltvector)
%function y = fcn(voltvector)
%#codegen
%test=voltvector
armcount=(max(size(voltvector))-1); %Determines the number of modules in an arm.
modulesOFF=voltvector(1,2); %Determines number of modules in arm to have zero voltage (SC)
gatesignal=zeros(armcount+1,1);
old_OFF=0;

for i=1:armcount; %Determining number of modules ON in the previous sample
    gatesignal(i)=voltvector(i+1,2);
    if voltvector(i+1,2) <= 0
        old_OFF=old_OFF+1;
    end
end

if (modulesOFF ~= old_OFF && modulesOFF ~= 0 && modulesOFF ~= armcount) %Initializing "voltages" given a 
    voltages=zeros(abs(modulesOFF-old_OFF),2);                                   %switching (not min/max) is set to occur
end

counter=0;
if modulesOFF == 0; % If all modules are to be ON
    for i=1:armcount;
        gatesignal(i)=1;
    end
    gatesignal(armcount+1)=old_OFF;
    Switched=1; %Switching already completed
elseif modulesOFF == armcount % If all modules are to be OFF
    for i=1:armcount
        gatesignal(i)=-1;
    end
    gatesignal(armcount+1)=armcount-old_OFF;
    Switched=1; %Switching already completed
elseif modulesOFF == old_OFF %If converter leg is to remain in previous state
    for i=1:armcount;
        gatesignal(i)=voltvector(i+1,2);
    end
    gatesignal(armcount+1)=0; 
    Switched=1; %Switching already completed
elseif modulesOFF > old_OFF %If a module is to be switched OFF
    voltages=zeros(armcount-old_OFF,2);
    for i=1:armcount;
        if voltvector(i+1,2) > 0
            counter=counter+1;
            voltages(counter,1)=voltvector(i+1,1);
            voltages(counter,2)=i; %Indexes the corresponding module
            
        end
    end
    gatesignal(armcount+1)=modulesOFF-old_OFF;
   % if gatesignal(armcount+1) ~= 1  %Testing
   %     a=4
   % end
    Switched=0; %Switching not completed
elseif modulesOFF < old_OFF %If a module is to be switched ON
    voltages=zeros((old_OFF),2);
    for i=1:armcount;
        if voltvector(i+1,2) <= 0
            counter=counter+1;
            voltages(counter,1)=voltvector(i+1,1);
            voltages(counter,2)=i; %Indexes the corresponding module
               
        end
    end
    gatesignal(armcount+1)=old_OFF-modulesOFF;
   % if gatesignal(armcount+1) ~= 1  %Testing
   %     old_OFF
   %     modulesOFF
   %     voltages
   % end
    Switched=0; %Switching not completed
end

%modulesOFF
%voltvector
%voltages
  
if Switched == 0
    [~,index]=sort(voltages, 1, 'ascend');
    if modulesOFF > old_OFF  %If a module is to be switched OFF
        if voltvector(1,1)==1 %If current is positive (capacitors charging)
            gatesignal(voltages(index(counter,1), 2))= -1; 
        elseif voltvector(1,1)== -1
            gatesignal(voltages(index(1,1), 2))= -1;
        end
    elseif modulesOFF < old_OFF %If a module is to be switched ON
        if voltvector(1,1) == 1  %If current is positive (capacitors charging) 
            gatesignal(voltages(index(1,1), 2))= 1;
        elseif voltvector(1,1) == -1 
            gatesignal(voltages(index(counter,1), 2))= 1;
        end
    end
end 

signalOFF=0;
for i=1:armcount;
    if gatesignal(i)==-1
        signalOFF=signalOFF+1;
    end
end
if signalOFF~=modulesOFF
   % voltvector
    %modulesOFF
    %old_OFF
    %signalOFF
end
        

end
   